module.exports = function (obj) {
  let map = {};
  for (let key in obj) {
    map[key] = (...values)=> {
      return new Promise((resolve, reject)=> {
        let result = 0;
        try {
          result =
            obj[key](...values, (err, ...data)=> {
              if (!err && !data) {
                resolve(true);
              } else if (err && data.length == 0) {
                reject(err);
              } else {
                if (!err) {
                  resolve(data.length > 1 ? data : data[0]);
                } else {
                  resolve([err, ...data]);
                }
              }
            });
          if (result)resolve(result);
        } catch (err) {
          reject(err);
        }
      })
    }
  }
  return map;
}
