module.exports = {
  Sync(gen, con, view, isGen) {
    return (req, res, next)=> {
      let g = gen.call(con, req, res, next, view);
      if (!g) return;
      if (!isGen) {
        let data = g;
        if (view)res.render(view, data)
        else if (typeof data == "string") res.send(data)
        else res.json(data);
        return;
      }
      function theNext(data) {
        let result = g.next(data);
        if (result.done) {
          let data = result.value;
          if (!data) return;
          if (view)res.render(view, data)
          else if (typeof data == "string") res.send(data)
          else res.json(data);
          return;
        }
        if (typeof result.value.length === "undefined") {
          result.value
            .then(data=>theNext(data))
            .catch(err=>next(err))
        } else {
          Promise.all(result.value)
            .then(data=>theNext(data))
            .catch(err=>next(err))
        }
      }

      theNext();
    }
  },

  Async(fn, self = this) {
    return (...values)=> {
      return new Promise((resolve, reject)=> {
        values.push((err, ...data)=> {
          if (!err && !data) {
            resolve(true);
          } else if (err && data.length == 0) {
            reject(err);
          } else {
            if (!err) {
              resolve(data.length > 1 ? data : data[0]);
            } else {
              resolve([err, ...data]);
            }
          }
        });
        fn.apply(self, values);
      });
    }
  },

  Go(gen, ...args) {
    let _this = this;

    return new Promise((resolve, reject)=> {
      if (typeof gen !== "function") reject(new Error("args1 is not a function"));
      let g = gen.apply(_this, args);
      if (typeof g.next === "undefined" || typeof g.next !== "function") reject(new Error("args1 is not a generator"));

      function next(data) {
        let result = g.next(data);
        if (result.done) resolve(result.value);
        if (typeof result.value.length === "undefined") {
          result.value.then(data=>next(data)).catch(err=> {
            reject(err);
          })
        } else {
          Promise.all(result.value).then(data=>next(data)).catch(err=> {
            reject(err);
          })
        }

      }

      next();
    })
  },

  sync(funName = "sync"){
    Object.defineProperty(Function.prototype, funName, {
      writable: true,
      enumerable: false,
      configurable: true,
      value(_this, ...args){
        let self = this;
        return new Promise((resolve, reject)=> {
          self.call(_this, ...args, (err, ...data)=> {
            if (!err && data.length == 0) resolve(true);
            else if (err && data.length == 0) reject(err);
            else if (!err) resolve(data.length > 1 ? data : data[0]);
            else resolve([err, ...data]);
          })
        })
      }
    });

    Object.defineProperty(Object.prototype, funName, {
      writable: true,
      enumerable: false,
      configurable: true,
      value(action, ...args) {
        let _this = this;
        return new Promise((resolve, reject)=> {
          _this[action](...args, (err, ...data)=> {
            if (!err && data.length == 0) resolve(true);
            else if (err && data.length == 0) reject(err);
            else if (!err) resolve(data.length > 1 ? data : data[0]);
            else resolve([err, ...data]);
          })
        })
      }
    })
  }
}
